#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "bus.h"
#include "sgstring.h"
#include "clock.h"

#define CG_CM0		(0x06)
#define CG_CM1		(0x07)
#define CG_MCD		(0x0c)
#define CG_CM2		(0x0d)
#define CG_PLC0		(0x26)
#define CG_PLC1 	(0x27)
#define CG_PM2		(0x13)
#define CG_TCSPR	(0x35f)


typedef struct M32C_CGen {
	BusDevice bdev;
} M32C_CGen;

static uint32_t
cm0_read(void *clientData,uint32_t address,int rqlen)
{

        return 0;
}

static void
cm0_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static uint32_t
cm1_read(void *clientData,uint32_t address,int rqlen)
{

        return 0;
}

static void
cm1_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static uint32_t
mcd_read(void *clientData,uint32_t address,int rqlen)
{
        return 0;
}

static void
mcd_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static uint32_t
cm2_read(void *clientData,uint32_t address,int rqlen)
{
        return 0;
}

static void
cm2_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static uint32_t
plc0_read(void *clientData,uint32_t address,int rqlen)
{
        return 0;
}

static void
plc0_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static uint32_t
plc1_read(void *clientData,uint32_t address,int rqlen)
{
        return 0;
}

static void
plc1_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static uint32_t
pm2_read(void *clientData,uint32_t address,int rqlen)
{
        return 0;
}

static void
pm2_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static uint32_t
tcspr_read(void *clientData,uint32_t address,int rqlen)
{
        return 0;
}

static void
tcspr_write(void *clientData,uint32_t value,uint32_t address,int rqlen)
{

}

static void
M32CCGen_Unmap(void *owner,uint32_t base,uint32_t mask)
{
	IOH_Delete8(CG_CM0);
	IOH_Delete8(CG_CM1);
	IOH_Delete8(CG_MCD);
	IOH_Delete8(CG_CM2);
	IOH_Delete8(CG_PLC0);
	IOH_Delete8(CG_PLC1);
	IOH_Delete8(CG_PM2);
	IOH_Delete8(CG_TCSPR);
}

static void
M32CCGen_Map(void *owner,uint32_t base,uint32_t mask,uint32_t mapflags)
{
        M32C_CGen *cgen = (M32C_CGen *) owner; 
	IOH_New8(CG_CM0,cm0_read,cm0_write,cgen);
	IOH_New8(CG_CM1,cm1_read,cm1_write,cgen);
	IOH_New8(CG_MCD,mcd_read,mcd_write,cgen);
	IOH_New8(CG_CM2,cm2_read,cm2_write,cgen);
	IOH_New8(CG_PLC0,plc0_read,plc0_write,cgen);
	IOH_New8(CG_PLC1,plc1_read,plc1_write,cgen);
	IOH_New8(CG_PM2,pm2_read,pm2_write,cgen);
	IOH_New8(CG_TCSPR,tcspr_read,tcspr_write,cgen);
}

BusDevice *
M32C_CGenNew(const char *name)
{
        M32C_CGen *cgen = sg_new(M32C_CGen);
        cgen->bdev.first_mapping=NULL;
        cgen->bdev.Map=M32CCGen_Map;
        cgen->bdev.UnMap=M32CCGen_Unmap;
        cgen->bdev.owner=cgen;
        cgen->bdev.hw_flags=MEM_FLAG_WRITABLE|MEM_FLAG_READABLE;
        //chgen->inclk = Clock_New("%s.inclk",name);
        //Clock_SetFreq(cgen->inclk,32000000); /* Should be connected instead */
        fprintf(stderr,"M32C Clock Generator \"%s\" created\n",name);
        return &cgen->bdev;
}

