RX_Instruction     **RxITab;

/*
 *******************************************************************
 * The instruction list
 * v0
 *******************************************************************
 */
static Rx_Instruction instrlist[] = {
{0x0000fff0,0x00007e20,"abs_dst",2		,rx_abs_dst},
{0x00ffff00,0x00fc0f00,"abs_src_dst",3		,rx_abs_src_dst},
{0x00fff3f0,0x00fd7020,"adc_imm_dst",3		,rx_adc_imm_dst},
{0xfffcff00,0x06600200,"adc_isrc_dst",4		,rx_adc_isrc_dst},
{0x0000ff00,0x00006200,"add_uimm_dst",2		,rx_add_uimm_dst},
/* Signed variants are missing in the manual */
{0x0000fc00,0x00004800,"add_src_dst_ub",2	,rx_add_src_dst_ub},
{0x00ff3c00,0x00060800,"add_src_dst_nub",3	,rx_add_src_dst_nub},
{0x0000fc00,0x00007000,"add_simm_src2_dst",2	,rx_add_simm_src2_dst},
{0x00fff000,0x00ff2000,"add_src_src2_dst",3	,rx_add_src_src2_dst},
{0x0000ff00,0x00006400,"and_uimm_dst",2		,rx_and_uimm_dst},
/* Signed variants are missing in the manual */
{0x0000fcf0,0x00007420,"and_imm_dst",2		,rx_and_imm_dst},
{0x0000fc00,0x00005000,"and_src_dst_ub",2	,rx_and_src_dst_ub},
{0x00ff3c00,0x00060400,"and_src_dst_nub",3	,rx_and_src_dst_nub},
{0x00fff000,0x00ff4000,"and_src_src2_dst",3	,rx_and_src_src2_dst},
{0x0000fc08,0x0000f008,"bclr_imm_dst",2		,rx_bclr_imm_dst},
{0x00fffc00,0x00fc6400,"bclr_rs_dst",3		,rx_bclr_rs_dst},
{0x0000ff00,0x00007a00,"bcrl_imm5_dst",2	,rx_bclr_imm5_dst},
{0x000000f0,0x00000010,"bcnd_s_src",1		,rx_bcnd_s_src},
{0x000000f0,0x00000020,"bcnd_b_src",1		,rx_bcnd_b_src},
{0x000000fe,0x0000003a,"bcnd_w_src",1		,rx_bcnd_w_src},
{0x00ffe000,0x00fce000,"bmcnd_im3_dst",3	,rx_bmcnd_imm3_dst},
{0x00ffe000,0x00fde000,"bmcnd_imm5_dst",3	,rx_bmcnd_src_dst},
{0x00ffe000,0x00fee000,"bnot_im3_dst",3		,rx_bnot_im3_dst},
{0x00fffc00,0x00fc6c00,"bnot_rs_dst",3		,rx_bnot_rs_dst},
{0x00ffe0f0,0x00fde0f0,"bnot_imm5_rd",3		,rx_bnot_imm5_rd},
{0x00fffc00,0x00fc6c00,"bnot_rs_rd",3		,rx_bnot_rs_rd},
{0x000000f8,0x00000008,"bra_s_src",1		,rx_bra_s_src},
{0x000000ff,0x0000002e,"bra_b_src",1		,rx_bra_b_src},
{0x000000ff,0x00000038,"bra_w_src",1		,rx_bra_w_src},
{0x000000ff,0x00000004,"bra_a_src",1		,rx_bra_a_src},
{0x0000fff0,0x00007f40,"bra_l_src",2		,rx_bra_l_src},
{0x000000ff,0x00000000,"brk",1			,rx_brk},
{0x0000fc08,0x0000f000,"bset_imm3_dst",2	,rx_bset_imm3_dst},
{0x00fffc00,0x00fc6000,"bset_rs_dst",3		,rx_bset_rs_dst},
{0x0000fe00,0x00007800,"bset_imm5_dst",2	,rx_bset_imm5_dst},
{0x00fffc00,0x00fc6000,"bset_rs_rd",3		,rx_bset_rs_rd},
{0x000000ff,0x00000039,"bsr_w_src",1		,rx_bsr_w_src},
{0x000000ff,0x00000005,"bsr_a_src",1		,rx_bsr_a_src},
{0x0000fff0,0x00007f50,"bsr_l_src",2		,rx_bsr_l_src},
{0x0000fc08,0x0000f400,"btst_imm3_src2",2	,rx_btst_imm3_src2},
{0x00fffc00,0x00fc6800,"btst_rs_src2",3		,rx_btst_rs_src2},
{0x0000fe00,0x00007c00,"btst_imm5_src2",2	,rx_btst_imm5_src2},
{0x00fffc00,0x00fc6800,"bstt_rs_rs2",3		,rx_btst_rs_rs2},
{0x0000fff0,0x00007fb0,"clrpsw",2		,rx_clrpsw},
{0x0000ff00,0x00006100,"cmp_uimm4_rs",2		,rx_cmp_uimm4_rs},
{0x0000fff0,0x00007550,"cmp_uimm8_rs",2		,rx_cmp_uimm4_rs},
{0x0000fcf0,0x00007400,"cmp_imm_rs",2		,rx_cmp_imm_rs},
{0x0000fc00,0x00004400,"cmp_ubrs_src2",2	,rx_cmp_ubrs_src2},
{0x00ff3c00,0x00060400,"cmp_memex_src2",3	,rx_cmp_memex_src2},
{0x00fff3f0,0x00fd7080,"div_imm_dst",3		,rx_div_imm_dst},
{0x00fffc00,0x00fc2000,"div_ubrs_dst",3		,rx_div_ubrs_dst},
{0xff3cff00,0x06200800,"div_memex_dst",4	,rx_div_memex_dst},
{0x00fff3f0,0x00fd7090,"divu_imm_dst",3		,rx_divu_imm_dst},
{0x00fffc00,0x00fc2400,"divu_ubrs_dst",3	,rx_divu_ubrs_dst},
{0xff3cff00,0x06200900,"divu_memex_dst",4	,rx_divu_memex_dst},
{0x00fff3f0,0x00fd7060,"emul_imm_dst",3		,rx_emul_imm_dst},
{0x00fffc00,0x00fc1800,"emul_ubrs_dst",3	,rx_emul_ubrs_dst},
{0xff3cff00,0x06200600,"emul_memex_dst",4	,rx_emul_memex_dst},
{0x00fff3f0,0x00fd7070,"emulu_imm_dst",3	,rx_emulu_imm_dst},
{0x00fffc00,0x00fc1c00,"emulu_ubrs_dst",3	,rx_emulu_ubrs_dst},
{0xff3cff00,0x06200700,"emulu_memex_dst",4	,rx_emulu_memex_dst},
{0x00fffff0,0x00fd7220,"fadd_imm32_rd",3	,rx_fadd_imm32_rd},
{0x00fffc00,0x00fc8200,"fadd_src_dst",3		,rx_fadd_src_dst},
{0x00fffff0,0x00fd7210,"fcmp_imm32_rs2",3	,rx_fcmp_imm32_rs2},
{0x00fffc00,0x00fc8100,"fcmp_src_src2",3	,rx_fcmp_src_src2},
{0x00fffff0,0x00fd7240,"fdiv_imm32_rd",3	,rx_fdiv_imm32_rd},
{0x00fffc00,0x00fc8900,"fdiv_src_dst",3		,rx_fdiv_src_dst},
{0x00fffff0,0x00fd7230,"fmul_imm32_rd",3	,rx_fmul_imm32_rd},
{0x00fffc00,0x00fc8c00,"fmul_src_dst",3		,rx_fmul_src_dst},
{0x00fffff0,0x00fd7200,"fsub_imm32_dst",3	,rx_fsub_imm32_dst},
{0x00fffc00,0x00fc8000,"fsub_src_dst",3		,rx_fsub_src_dst},
{0x00fffc00,0x00fc9400,"ftoi_src_dst",3		,rx_ftoi_src_dst},
{0x0000ffff,0x00007560,"int",3			,rx_int},
{0x00fffc00,0x00fc4400,"itof_ubrs_rd",3		,rx_itof_ubrs_rd},
{0xff3cff00,0x06201100,"itof_src_dst",4		,rx_src_dst},
{0x0000fff0,0x00007f00,"jmp_rs",2		,rx_jmp_rs},
{0x00ffff00,0x00fd0400,"machi",3		,rx_machi},
{0x00ffff00,0x00fd0500,"maclo",3		,rx_maclo},
{0x00fff3f0,0x00fd7040,"max_simm_rd",3		,rx_max_simm_rd},
{0x00fffc00,0x00fc1000,"max_srcub_dst",3	,rx_max_srcub_dst},
{0xff3cff00,0x06200400,"max_src_dst",4		,rx_max_src_dst},
{0x00fff3f0,0x00fd7050,"min_simm_rd",3		,rx_min_simm_rd},
{0x00fffc00,0x00fc1400,"min_srcub_dst",3	,rx_min_srcub_rd},
{0xff3cff00,0x06200500,"min_src_dst",4		,rx_min_src_dst},
{0x0000c800,0x00008000,"mov_rs_dsp5_rd",2	,rx_mov_rs_dsp5_rd},
{0x0000c800,0x00008800,"mov_dsp5_rs_rd",2	,rx_mov_dsp5_rs_rd},	
{0x0000ff00,0x00006600,"mov_uimm4_rd",2		,rx_mov_uimm4_rd},
{0x0000fc00,0x00003c00,"mov_imm8_dsp5_rd",2	,rx_mov_imm8_dsp5_rd},
{0x0000fff0,0x00007540,"mov_uimm8_rd",2		,rx_mov_uimm8_rd},
{0x0000ff03,0x0000fb02,"mov_simm_rd",2		,rx_mov_simm_rd},
{0x0000cf00,0x0000cf00,"mov_rs_rd",2		,rx_mov_rs_rd},
{0x0000fc00,0x0000f800,"mov_simm_dsp_ird",2	,rx_mov_simm_dsp_ird},
{0x0000cc00,0x0000cc00,"mov_dsp_irs_rd",2	,rx_mov_dsp_irs_rd},
{0x00ffc000,0x00fe4000,"mov_irirb_rd",3		,rx_mov_irirb_rd},
{0x0000c300,0x0000c300,"mov_rs_dsp_ird",2	,rx_mov_rs_dsp_irq},
{0x00ffc000,0x00fe0000,"mov_rs_irird",3		,rx_mov_rs_irird},
{0x0000c000,0x0000c000,"mov_dsp_irs_dsp_ird",2	,rx_mov_dsp_irs_dsp_irq},
{0x00fff800,0x00fd2000,"mov_rs_irdpm",3,	,rx_mov_rs_irdpm},
{0x00fff800,0x00fd2800,"mov_irspm_rd",3,	,rx_mov_irspm_rd},
{0x0000ffff,0x0000b000,"movu_dsp5_rs_rd",2	,rx_movu_dsp5_rs_rd},
{0x0000f800,0x00005800,"movu_src_rd",2		,rx_movu_src_rd},
{0x00ffe000,0x00fec000,"movu_irirb_rd",3	,rx_movu_irirb_rd},
{0x00fff200,0x00fd3000,"movu_rspm_rd",3		,rx_movu_rspm_rd},
{0x0000ff00,0x00006300,"mul_uimm4_rd",2		,rx_mul_uimm4_rd},
{0x0000fcf0,0x00007410,"mul_simm_rd",2		,rx_mul_simm_rd},
{0x0000fc00,0x00004c00,"mul_srcub_rd",2		,rx_mul_srcub_rd},
{0x00ff3c00,0x00060c00,"mul_src_rd",3		,rx_mul_srcub_rd},
{0x00fff000,0x00ff3000,"mul_rsrs2_rd",3		,rx_mul_rsrs2_rd},
{0x00ffff00,0x00fd0000,"mulhi_rs_rs2",3		,rx_mulhi_rs_rs2},
{0x00ffff00,0x00fd0100,"mullo_rs_rs2",3		,rx_mullo_rs_rs2},
{0x00fffff0,0x00fd1f00,"mvfachi_rd",3		,rx_mvfachi},
{0x00fffff0,0x00fd1f20,"mvfacmi_rd",3		,rx_mvfacmi},
}
